% Bepaal die oordragsfunksies van die anti-oorvleueling- en ontvangerfilter van die G3RUH-modem
% deur die node-vergelykings vir beide filters simbolies op te los en dan waardes in te stel.

% Johann Lochner (8/11/97)

% Die volgende ler word geskep:
% filters.mat	filterkoffisinte van TX-filter en RX-filter

clear all;

% -----------------------------------------------------------------------------------------------

f1='(E1-E3)*s*C1 - E3/R1 + (E4-E3)/R2';			% seksie 1 se node-vergelykings
f2='(E4-E3)/R2 + (E4-E5)/R3 + (E4-E5)*s*C2';		
f3='(E4-E5)/R3 - E5*s*C3';
[E3 E4 E5]=solve(f1,f2,f3, 'E3,E4,E5');			% omskryf seksie se odf as funksie van s
odf1=simple(subs(E5, '1', 'E1'));

f4='(E5-E6)/R4 - E6/R5 - E6/R6';			% seksie 2
f5='-E6/R6 - E7/R7 - E7*s*C4';
[E6 E7]=solve(f4,f5, 'E6,E7');
odf2=simple(subs(E7, '1', 'E5'));

f6='(E2-E7)*s*C5 + E2/R8';				% seksie 3
[E23]=solve(f6, 'E2');
odf3=simple(subs(E23, '1', 'E7'));

f7='(E2-E5)/R4 + E2*s*C4';				% seksie 4
[E24]=solve(f7, 'E2');
odf4=simple(subs(E24, '1', 'E5'));

TX_filter=symmul(symmul(odf1,odf2),odf3);		% TX-filter bestaan uit drie seksies
RX_filter=symmul(odf1,odf4);				% RX-filter bestaan uit twee seksies

TX_filter=subs(TX_filter, '10e3',	'R1');		% Vervang simboliese waardes in TX-filter met numeriese waardes
TX_filter=subs(TX_filter, '100e3',	'R2');
TX_filter=subs(TX_filter, '56e3',	'R3');
TX_filter=subs(TX_filter, '10e3-R5',	'R4');
TX_filter=subs(TX_filter, '5e3',	'R5');
TX_filter=subs(TX_filter, '3.3e3',	'R6');
TX_filter=subs(TX_filter, '12e3',	'R7');
TX_filter=subs(TX_filter, '500',	'R8');
TX_filter=subs(TX_filter, '10e-6',	'C1');
TX_filter=subs(TX_filter, '470e-12',	'C2');
TX_filter=subs(TX_filter, '100e-12',	'C3');
TX_filter=subs(TX_filter, '1e-9',	'C4');
TX_filter=subs(TX_filter, '100e-6',	'C5');

RX_filter=subs(RX_filter, '100e3',	'R1');		% Vervang simboliese waardes in RX-filter met numeriese waardes
RX_filter=subs(RX_filter, '82e3',	'R2');
RX_filter=subs(RX_filter, '39e3',	'R3');
RX_filter=subs(RX_filter, '27e3',	'R4');
RX_filter=subs(RX_filter, '100e-9',	'C1');
RX_filter=subs(RX_filter, '1e-9',	'C2');
RX_filter=subs(RX_filter, '220e-12',	'C3');
RX_filter=subs(RX_filter, '1e-9',	'C4');

[n,d]=numden(TX_filter);				% skei noemer en teller
TX_teller=sym2poly(expand(n));				% omskryf simboliese uitdrukking as koffisintvektor
TX_noemer=sym2poly(expand(d));				% transformeer van s-vlak na z-vlak

[n,d]=numden(RX_filter);				% ditto
RX_teller=sym2poly(expand(n));
RX_noemer=sym2poly(expand(d));

save filters TX_teller TX_noemer RX_teller RX_noemer;	% stoor filterkoffisinte